CMAKE_MINIMUM_REQUIRED( VERSION 2.6 )

# Executable name:
SET(EXEC_NAME ${basename})


# The version number.
set (${'$'}{EXEC_NAME}_VERSION_MAJOR 0)
set (${'$'}{EXEC_NAME}_VERSION_MINOR 1)

PROJECT( ${'$'}{EXEC_NAME} )

# Directory where program dependencies are located
SET( BASE_DIR "/space/install" CACHE PATH 
                            "Top istall dir for program dependencies")

SET(CMAKE_MODULE_PATH "${'$'}{CMAKE_SOURCE_DIR}/config/cmake_modules/")


% if cmdlgener == 'autoopt':
SET( CMDL_DEF ${'$'}{EXEC_NAME}_cmdl.def)
SET( CMDL_SRC ${'$'}{EXEC_NAME}_cmdl.h ${'$'}{EXEC_NAME}_cmdl.c)
%endif 

SET( SRCS ${'$'}{EXEC_NAME}.cxx ${'$'}{CMDL_SRC})

# configure a header file to pass some of the CMake settings
# to the source code
CONFIGURE_FILE (
  "${'$'}{PROJECT_SOURCE_DIR}/${'$'}{EXEC_NAME}_config.h.in"
  "${'$'}{PROJECT_BINARY_DIR}/${'$'}{EXEC_NAME}_config.h"
)

% if cmdlgener == 'autoopt':
FIND_PACKAGE(PkgConfig QUIET)

PKG_CHECK_MODULES(AUTOOPTS autoopts)

FIND_PROGRAM(AUTOOPTS_CONFIG NAMES autoopts-config)

EXECUTE_PROCESS(COMMAND "${'$'}{AUTOOPTS_CONFIG}" --autogen
                OUTPUT_VARIABLE AUTOGEN_PROGRAM
                OUTPUT_STRIP_TRAILING_WHITESPACE
)
EXECUTE_PROCESS(COMMAND "${'$'}{AUTOOPTS_CONFIG}" --pkgdatadir
                OUTPUT_VARIABLE AUTOGEN_DATADIR
                OUTPUT_STRIP_TRAILING_WHITESPACE
)
SET(AUTOGEN_FLAGS "-L${'$'}{AUTOGEN_DATADIR}")
STRING(STRIP ${'$'}{AUTOGEN_PROGRAM} AUTOGEN_PROGRAM)

ADD_CUSTOM_COMMAND (
  OUTPUT ${'$'}{CMDL_SRC}
  COMMAND "${'$'}{AUTOGEN_PROGRAM}" "${'$'}{AUTOGEN_FLAGS}" ${'$'}{CMAKE_CURRENT_SOURCE_DIR}/${'$'}{CMDL_DEF}
  DEPENDS ${'$'}{CMDL_DEF} 
  COMMENT "Runing autogen to generate options processing source files"
  VERBATIM
)

LINK_DIRECTORIES(
     ${'$'}{AUTOOPTS_LIBRARY_DIRS}
)

%endif 

# Add the binary tree to the search path so the compiler will find
# the generated configuration file
INCLUDE_DIRECTORIES(${'$'}{PROJECT_BINARY_DIR})
% if cmdlgener == 'autoopt':
INCLUDE_DIRECTORIES(${'$'}{AUTOOPTS_INCLUDE_DIRS})
% endif



# Uncomment and specify package name used by program if any
# FIND_PACKAGE(GetFEM)

# Add any specific directores required by a program to compile
# INCLUDE_DIRECTORIES( ${'$'}{GETFEM_INCLUDE_DIRS} ) 

ADD_EXECUTABLE( ${'$'}{EXEC_NAME} ${'$'}{SRCS} )

%if cmdlgener == 'autoopt':
TARGET_LINK_LIBRARIES(${'$'}{EXEC_NAME} ${'$'}{AUTOOPTS_LIBRARIES} )
% endif

# Add any specific libraries required by a program  to link
# TARGET_LINK_LIBRARIES( ${'$'}{EXEC_NAME} ${'$'}{GETFEM_LIBRARIES} )

INSTALL( PROGRAMS ${'$'}{CMAKE_CURRENT_BINARY_DIR}/${'$'}{EXEC_NAME} DESTINATION bin )
