/*
% if femdk:
 * This file is a part of FEMDK, a Finite Element Method Development Kit.
 * FEMDK provides utilities of develping simulation codes base on various 
 * variants of finite element method.
 *
 * Project web page: https://femdk.l5.pk.edu.pl/femdk
% endif
 * 
 * Copyright (c) ${year} ${owner} 
 * 
% if license == 'BSD':
 * This file is distributed on "Simplified BSD License" as approved by 
 * the OSI Board. For licensing terms see COPYING file distributed 
 * with his file.
% endif
 */

/*
 * Author: ${author} <${email}>
 * Created: ${date}
 * Modified by:
 */

/** 
 *  FIXME : describe the purpose of this file here
 */
#include "${basename}_config.h"
#include <stdlib.h> // for EXIT_SUCCESS
%if cmdlgener == 'autoopt':
#include "${basename}_cmdl.h" 
%endif
#include <iostream>

int main_body();

/** main function
 * 
 * This function should contain command line parsing and initialization
 * code. The real work should be done by calling main_body().
 */
int main(int argc, char **argv) {
  int result =  EXIT_SUCCESS;
%if cmdlgener == 'autoopt':  
  {
     int optct = optionProcess(&${basename}Options, argc, argv);
     argc -= optct;
     argv += optct;
  }
  if (HAVE_OPT(DUMMY)) {
    std::cout << "Dummy option value: ";
    const char* val = OPT_ARG(DUMMY);
    std::cout << val << "\n";
  }
%endif
  result = main_body();

  return result;
}

/** The function where the main work is done after configuration
 * and command line parsing.
 */
int main_body() {
  int result;
  result = EXIT_SUCCESS;
  return result;
}
